#include "stdafx.h"
#include <afxdb.h>
#include "addtrans.h"
#include "winfile.h"
#include "statdlg.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//just override the ExecuteSQL member, everthing else stays the same
class CDBSyncDatabase : public CDatabase
{

public:
	BOOL ExecuteSQL(LPCSTR lpszSQL);
};




/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 class CDBSyncException : public CException
{
DECLARE_DYNAMIC(CDBSyncException)

public:
    CDBSyncException(int nErrCode = 0);	    
    virtual ~CDBSyncException();
	
public:
	int m_nErrCode;
	CString m_strError;
		
protected:
	#ifdef _DEBUG
		virtual void AssertValid()
			{CObject::AssertValid();}
	#endif // _DEBUG	    

};

void AFXAPI ThrowDBSyncException(int nErrCode);




/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class CDBSync : public CObject
{
public:	
	CDBSync(LPCSTR lpcstrFileName = NULL, LPCSTR lpcstrOrigFileTitle = NULL, LPCSTR lpcstrDSN = NULL);
	~CDBSync();
	
	//STATIC
	static BOOL ApplyTransactionFile(HWND hWnd, 
		LPCSTR lpcstrSenderMailName, LPCSTR lpcstrFileName, LPCSTR lpcstrOrigFileTitle,
		LPCSTR lpcstrDSN, BOOL bSaveLocalCopy = FALSE);

//operations
public:	
	BOOL DoSync();
	BOOL UserAborted()
		{return m_bUserAbort;}

//public data
public:	
	BOOL m_bSaveLocalCopy;
	CString m_strSenderMailName;
	CStatusDlg* m_pStatusDlg;	
	CWnd m_ParentWnd;
protected:
	BOOL Init(LPCSTR lpcstrFileName, LPCSTR lpcstrOrigFileTitle, LPCSTR lpcstrDSN);
	
	BOOL ExecuteSQL(LPCSTR lpcstrSQL);	
	BOOL OpenDatabase();
	BOOL InsertTransaction(CStringArray& strValueList);
	
	BOOL LogAsApplied(int iRowsRead, int iRowsApplied);	
	void DoErrorMsg(CDBException* e) const;
	
	BOOL IsApplied(LPCSTR lpcstrFile, LPCSTR lpcstrSentBy) const;
	
private:
	CAddTrans* m_pAddTransSet;
	CWinFile* m_pFile;
	CDBSyncDatabase* m_pDb;		//NOT CDatabase() !
	CString m_strFileName;
	CString m_strOrigFileTitle;
	CString m_strDSN;
	char* m_szLineBuf;
	char* m_szCopyBuf;
	BOOL m_bUserAbort;
	BOOL m_bShowErrorMessages;
	

DECLARE_DYNAMIC(CDBSync)

};

#ifdef _DEBUG
#ifdef _WIN32 
	#define DBX_EXPORT
#else
	#define DBX_EXPORT __export
#endif //_WIN32

extern "C" int WINAPI DBX_EXPORT ApplyTransactionFile(LPCSTR lpcstrFileName, LPCSTR lpcstrDSN, BOOL bSaveLocalCopy);
#endif //_DEBUG
