class CWinFileException : public CException
{
DECLARE_DYNAMIC(CWinFileException)

public:
    CWinFileException();	    
    virtual ~CWinFileException();
	
public:
	int m_nErrCode;
		
protected:
	#ifdef _DEBUG
		virtual void AssertValid()
			{CObject::AssertValid();}
	#endif // _DEBUG	    

};

void AFXAPI ThrowWinFileException(int nErrCode);


class CWinFile : public CObject
{
public:
	CWinFile(UINT nBufSize = 4096);
	~CWinFile();
	BOOL Open(LPCSTR lpcstrFileName, int nMode = OF_READ);
	void Close();
	LPSTR ReadString(LPSTR lpsz, UINT nMax);
	void SeekToBegin();
	void SeekToEnd();	
	BOOL IsOpen() 
		{return (HFILE_ERROR != m_hFile);}
	
private:
	HFILE m_hFile;
  	UINT m_nCurPos;
  	UINT m_nEOF;
  	UINT m_nBufSize;
  	char* m_pszBuf;

protected:
	void Reset();
	
	DECLARE_DYNAMIC(CWinFile)
  	
  	
#ifdef _DEBUG
	virtual void AssertValid() const
			{ CObject::AssertValid(); }
#endif //_DEBUG 
};

